diff --git a/src/charts/axis/verticalaxis2_p.h b/src/charts/axis/verticalaxis2_p.h
index b372c777..601a0afc 100644
--- a/src/charts/axis/verticalaxis2_p.h
+++ b/src/charts/axis/verticalaxis2_p.h
@@ -47,7 +47,7 @@ QT_CHARTS_BEGIN_NAMESPACE
 class QT_CHARTS_PRIVATE_EXPORT VerticalAxis2 : public CartesianChartAxis2
 {
 public:
-    VerticalAxis2(QAbstractAxis *axis, QGraphicsItem *item = nullptr, bool intervalAxis = false);
+    VerticalAxis2(QAbstractAxis *axis, QQuickItem *item = nullptr, bool intervalAxis = false);
     ~VerticalAxis2();
 
     QSizeF sizeHint(Qt::SizeHint which, const QSizeF &constraint = QSizeF()) const override;
diff --git a/src/charts/barchart/abstractbarchartitem2.cpp b/src/charts/barchart/abstractbarchartitem2.cpp
index 8d574dfa..ff914874 100644
--- a/src/charts/barchart/abstractbarchartitem2.cpp
+++ b/src/charts/barchart/abstractbarchartitem2.cpp
@@ -45,7 +45,7 @@
 
 QT_CHARTS_BEGIN_NAMESPACE
 
-AbstractBarChartItem2::AbstractBarChartItem2(QAbstractBarSeries *series, QGraphicsItem* item) :
+AbstractBarChartItem2::AbstractBarChartItem2(QAbstractBarSeries *series, QQuickItem* item) :
     ChartItem2(series->d_func(),item),
     m_animation(0),
     m_series(series),
@@ -58,7 +58,7 @@ AbstractBarChartItem2::AbstractBarChartItem2(QAbstractBarSeries *series, QGraphi
 {
     setAcceptedMouseButtons(0);
     setFlag(ItemClipsChildrenToShape);
-    setFlag(QGraphicsItem::ItemIsSelectable);
+//    setFlag(QQuickItem::ItemIsSelectable);
     connect(series->d_func(), SIGNAL(updatedLayout()), this, SLOT(handleLayoutChanged()));
     connect(series->d_func(), SIGNAL(updatedBars()), this, SLOT(handleUpdatedBars()));
     connect(series->d_func(), SIGNAL(labelsVisibleChanged(bool)), this, SLOT(handleLabelsVisibleChanged(bool)));
@@ -91,7 +91,7 @@ AbstractBarChartItem2::AbstractBarChartItem2(QAbstractBarSeries *series, QGraphi
         connect(series->chart2()->d_ptr->m_dataset, &ChartDataSet::seriesRemoved,
                 this, &AbstractBarChartItem2::handleSeriesRemoved);
     }
-    setZValue(ChartPresenter2::BarSeriesZValue);
+//    setZValue(ChartPresenter2::BarSeriesZValue);
     calculateSeriesPositionAdjustmentAndWidth();
     handleDataStructureChanged();
 }
@@ -195,7 +195,7 @@ void AbstractBarChartItem2::handleDomainUpdated()
     QRectF rect(QPointF(0,0),domain()->size());
 
     if(m_rect != rect){
-        prepareGeometryChange();
+//        prepareGeometryChange();
         m_rect = rect;
     }
 
@@ -256,7 +256,7 @@ void AbstractBarChartItem2::handleVisibleChanged()
 
 void AbstractBarChartItem2::handleOpacityChanged()
 {
-    foreach (QGraphicsItem *item, childItems())
+    foreach (QQuickItem *item, childItems())
         item->setOpacity(m_series->opacity());
 }
 
@@ -380,7 +380,7 @@ void AbstractBarChartItem2::positionLabels()
             }
 
             label->setPos(xPos, yPos);
-            label->setZValue(zValue() + 1);
+//            label->setZValue(zValue() + 1);
         }
     }
 }
@@ -501,7 +501,7 @@ void AbstractBarChartItem2::positionLabelsVertical()
             }
 
             label->setPos(xPos, yPos);
-            label->setZValue(zValue() + 1);
+//            label->setZValue(zValue() + 1);
         }
     }
 }
@@ -520,10 +520,10 @@ void AbstractBarChartItem2::createLabelItems()
         for (int j = 0; j < bars.size(); j++) {
             QGraphicsTextItem *label = bars.at(j)->labelItem();
             if (!label) {
-                QGraphicsTextItem *newLabel = new QGraphicsTextItem(this);
-                newLabel->setAcceptHoverEvents(false);
-                newLabel->document()->setDocumentMargin(ChartPresenter2::textMargin());
-                bars.at(j)->setLabelItem(newLabel);
+//                QGraphicsTextItem *newLabel = new QGraphicsTextItem(this);
+//                newLabel->setAcceptHoverEvents(false);
+//                newLabel->document()->setDocumentMargin(ChartPresenter2::textMargin());
+//                bars.at(j)->setLabelItem(newLabel);
             }
         }
     }
@@ -578,118 +578,119 @@ QString AbstractBarChartItem2::generateLabelText(int set, int category, qreal va
 
 void AbstractBarChartItem2::updateBarItems()
 {
-    int min(0);
-    int max(0);
-    if (m_orientation == Qt::Vertical) {
-        min = qFloor(domain()->minX()) - 1;
-        max = qCeil(domain()->maxX()) + 1;
-    } else {
-        min = qFloor(domain()->minY()) - 1;
-        max = qCeil(domain()->maxY()) + 1;
-    }
-
-    int lastBarIndex = m_series->d_func()->categoryCount() - 1;
-
-    if (lastBarIndex < 0) {
-        // Indicate invalid categories by negatives
-        // Last should be one less than the first to make loops work right in case of no categories
-        m_firstCategory = -1;
-        m_lastCategory = -2;
-        m_categoryCount = 0;
-    } else {
-        m_firstCategory = qMax(qMin(min, lastBarIndex), 0);
-        m_lastCategory = qMax(qMin(max, lastBarIndex), m_firstCategory);
-        m_categoryCount = m_lastCategory - m_firstCategory + 1;
-    }
-
-    QList<QBarSet *> newSets = m_series->barSets();
-    QList<QBarSet *> oldSets = m_barMap.keys();
-
-    Q_ASSERT(newSets.size() == oldSets.size());
-
-    int layoutSize = m_categoryCount * newSets.size();
-
-    QVector<QRectF> oldLayout = m_layout;
-    if (layoutSize != m_layout.size())
-        m_layout.resize(layoutSize);
-
-    // Create new graphic items for bars or remove excess ones
-    int layoutIndex = 0;
-    for (int s = 0; s < newSets.size(); s++) {
-        QBarSet *set = newSets.at(s);
-        QList<Bar *> bars = m_barMap.value(set);
-        int addCount = m_categoryCount - bars.size();
-        if (addCount > 0) {
-            for (int c = 0; c < addCount; c++) {
-                Bar *bar = new Bar(set, this);
-                bars.append(bar);
-                connect(bar, &Bar::clicked, m_series, &QAbstractBarSeries::clicked);
-                connect(bar, &Bar::hovered, m_series, &QAbstractBarSeries::hovered);
-                connect(bar, &Bar::pressed, m_series, &QAbstractBarSeries::pressed);
-                connect(bar, &Bar::released, m_series, &QAbstractBarSeries::released);
-                connect(bar, &Bar::doubleClicked, m_series, &QAbstractBarSeries::doubleClicked);
-
-                connect(bar, &Bar::clicked, set, &QBarSet::clicked);
-                connect(bar, &Bar::hovered, set, &QBarSet::hovered);
-                connect(bar, &Bar::pressed, set, &QBarSet::pressed);
-                connect(bar, &Bar::released, set, &QBarSet::released);
-                connect(bar, &Bar::doubleClicked, set, &QBarSet::doubleClicked);
-
-                m_labelItemsMissing = true;
-            }
-        }
-        // Update bar indexes
-        QHash<int, Bar*> indexMap;
-        QVector<Bar *> unassignedBars(m_categoryCount, nullptr);
-        int unassignedIndex(0);
-        QList<Bar *> newBars;
-        newBars.reserve(m_categoryCount);
-        for (int c = 0; c < bars.size(); c++) {
-            Bar *bar = bars.at(c);
-            if (bar->index() < m_firstCategory || bar->index() > m_lastCategory) {
-                // Delete excess unassigned bars first
-                if (addCount < 0) {
-                    addCount++;
-                    delete bar;
-                    bar = nullptr;
-                } else {
-                    unassignedBars[unassignedIndex++] = bar;
-                    bar->setLayoutIndex(layoutIndex);
-                    newBars.append(bar);
-                    layoutIndex++;
-                }
-            } else {
-                indexMap.insert(bar->index(), bar);
-                newBars.append(bar);
-                m_layout[layoutIndex] = oldLayout.at(bar->layoutIndex());
-                bar->setLayoutIndex(layoutIndex);
-                layoutIndex++;
-            }
-        }
-        unassignedIndex = 0;
-        for (int c = m_firstCategory; c <= m_lastCategory; c++) {
-            Bar *bar = indexMap.value(c);
-            if (!bar) {
-                bar = unassignedBars.at(unassignedIndex++);
-                bar->setIndex(c);
-                indexMap.insert(bar->index(), bar);
-            }
-        }
-
-        m_indexForBarMap.insert(set, indexMap);
-
-        if (m_animation) {
-            for (int i = 0; i < unassignedIndex; i++) {
-                Bar *bar = unassignedBars.at(i);
-                initializeLayout(s, bar->index(), bar->layoutIndex(), m_resetAnimation);
-                bar->setRect(m_layout.at(bar->layoutIndex()));
-                // Make bar initially hidden to avoid artifacts, layout setting will show it
-                bar->setVisible(false);
-            }
-        }
-
-        m_barMap.insert(set, newBars);
-    }
+    // TODO!!
+//    int min(0);
+//    int max(0);
+//    if (m_orientation == Qt::Vertical) {
+//        min = qFloor(domain()->minX()) - 1;
+//        max = qCeil(domain()->maxX()) + 1;
+//    } else {
+//        min = qFloor(domain()->minY()) - 1;
+//        max = qCeil(domain()->maxY()) + 1;
+//    }
+
+//    int lastBarIndex = m_series->d_func()->categoryCount() - 1;
+
+//    if (lastBarIndex < 0) {
+//        // Indicate invalid categories by negatives
+//        // Last should be one less than the first to make loops work right in case of no categories
+//        m_firstCategory = -1;
+//        m_lastCategory = -2;
+//        m_categoryCount = 0;
+//    } else {
+//        m_firstCategory = qMax(qMin(min, lastBarIndex), 0);
+//        m_lastCategory = qMax(qMin(max, lastBarIndex), m_firstCategory);
+//        m_categoryCount = m_lastCategory - m_firstCategory + 1;
+//    }
+
+//    QList<QBarSet *> newSets = m_series->barSets();
+//    QList<QBarSet *> oldSets = m_barMap.keys();
+
+//    Q_ASSERT(newSets.size() == oldSets.size());
+
+//    int layoutSize = m_categoryCount * newSets.size();
+
+//    QVector<QRectF> oldLayout = m_layout;
+//    if (layoutSize != m_layout.size())
+//        m_layout.resize(layoutSize);
+
+//    // Create new graphic items for bars or remove excess ones
+//    int layoutIndex = 0;
+//    for (int s = 0; s < newSets.size(); s++) {
+//        QBarSet *set = newSets.at(s);
+//        QList<Bar *> bars = m_barMap.value(set);
+//        int addCount = m_categoryCount - bars.size();
+//        if (addCount > 0) {
+//            for (int c = 0; c < addCount; c++) {
+//                Bar *bar = new Bar(set, this);
+//                bars.append(bar);
+//                connect(bar, &Bar::clicked, m_series, &QAbstractBarSeries::clicked);
+//                connect(bar, &Bar::hovered, m_series, &QAbstractBarSeries::hovered);
+//                connect(bar, &Bar::pressed, m_series, &QAbstractBarSeries::pressed);
+//                connect(bar, &Bar::released, m_series, &QAbstractBarSeries::released);
+//                connect(bar, &Bar::doubleClicked, m_series, &QAbstractBarSeries::doubleClicked);
+
+//                connect(bar, &Bar::clicked, set, &QBarSet::clicked);
+//                connect(bar, &Bar::hovered, set, &QBarSet::hovered);
+//                connect(bar, &Bar::pressed, set, &QBarSet::pressed);
+//                connect(bar, &Bar::released, set, &QBarSet::released);
+//                connect(bar, &Bar::doubleClicked, set, &QBarSet::doubleClicked);
+
+//                m_labelItemsMissing = true;
+//            }
+//        }
+//        // Update bar indexes
+//        QHash<int, Bar*> indexMap;
+//        QVector<Bar *> unassignedBars(m_categoryCount, nullptr);
+//        int unassignedIndex(0);
+//        QList<Bar *> newBars;
+//        newBars.reserve(m_categoryCount);
+//        for (int c = 0; c < bars.size(); c++) {
+//            Bar *bar = bars.at(c);
+//            if (bar->index() < m_firstCategory || bar->index() > m_lastCategory) {
+//                // Delete excess unassigned bars first
+//                if (addCount < 0) {
+//                    addCount++;
+//                    delete bar;
+//                    bar = nullptr;
+//                } else {
+//                    unassignedBars[unassignedIndex++] = bar;
+//                    bar->setLayoutIndex(layoutIndex);
+//                    newBars.append(bar);
+//                    layoutIndex++;
+//                }
+//            } else {
+//                indexMap.insert(bar->index(), bar);
+//                newBars.append(bar);
+//                m_layout[layoutIndex] = oldLayout.at(bar->layoutIndex());
+//                bar->setLayoutIndex(layoutIndex);
+//                layoutIndex++;
+//            }
+//        }
+//        unassignedIndex = 0;
+//        for (int c = m_firstCategory; c <= m_lastCategory; c++) {
+//            Bar *bar = indexMap.value(c);
+//            if (!bar) {
+//                bar = unassignedBars.at(unassignedIndex++);
+//                bar->setIndex(c);
+//                indexMap.insert(bar->index(), bar);
+//            }
+//        }
+
+//        m_indexForBarMap.insert(set, indexMap);
+
+//        if (m_animation) {
+//            for (int i = 0; i < unassignedIndex; i++) {
+//                Bar *bar = unassignedBars.at(i);
+//                initializeLayout(s, bar->index(), bar->layoutIndex(), m_resetAnimation);
+//                bar->setRect(m_layout.at(bar->layoutIndex()));
+//                // Make bar initially hidden to avoid artifacts, layout setting will show it
+//                bar->setVisible(false);
+//            }
+//        }
+
+//        m_barMap.insert(set, newBars);
+//    }
 }
 
 void AbstractBarChartItem2::markLabelsDirty(QBarSet *barset, int index, int count)
diff --git a/src/charts/barchart/abstractbarchartitem2_p.h b/src/charts/barchart/abstractbarchartitem2_p.h
index 765c3a41..eedf7a08 100644
--- a/src/charts/barchart/abstractbarchartitem2_p.h
+++ b/src/charts/barchart/abstractbarchartitem2_p.h
@@ -59,7 +59,7 @@ class QT_CHARTS_PRIVATE_EXPORT AbstractBarChartItem2 : public ChartItem2
 {
     Q_OBJECT
 public:
-    AbstractBarChartItem2(QAbstractBarSeries *series, QGraphicsItem* item = 0);
+    AbstractBarChartItem2(QAbstractBarSeries *series, QQuickItem* item = 0);
     virtual ~AbstractBarChartItem2();
 
 public:
diff --git a/src/charts/barchart/vertical/bar/barchartitem2.cpp b/src/charts/barchart/vertical/bar/barchartitem2.cpp
index 56dd77c8..43975357 100644
--- a/src/charts/barchart/vertical/bar/barchartitem2.cpp
+++ b/src/charts/barchart/vertical/bar/barchartitem2.cpp
@@ -35,7 +35,7 @@
 
 QT_CHARTS_BEGIN_NAMESPACE
 
-BarChartItem2::BarChartItem2(QAbstractBarSeries *series, QGraphicsItem* item) :
+BarChartItem2::BarChartItem2(QAbstractBarSeries *series, QQuickItem* item) :
     AbstractBarChartItem2(series, item)
 {
     m_orientation = Qt::Vertical;
diff --git a/src/charts/barchart/vertical/bar/barchartitem2_p.h b/src/charts/barchart/vertical/bar/barchartitem2_p.h
index 5dd13984..de4c3190 100644
--- a/src/charts/barchart/vertical/bar/barchartitem2_p.h
+++ b/src/charts/barchart/vertical/bar/barchartitem2_p.h
@@ -42,7 +42,7 @@
 
 #include "abstractbarchartitem2_p.h"
 #include <QtCharts/QStackedBarSeries>
-#include <QtWidgets/QGraphicsItem>
+#include <QQuickItem>
 #include <QtCharts/private/qchartglobal_p.h>
 
 QT_CHARTS_BEGIN_NAMESPACE
@@ -51,7 +51,7 @@ class QT_CHARTS_PRIVATE_EXPORT BarChartItem2 : public AbstractBarChartItem2
 {
     Q_OBJECT
 public:
-    BarChartItem2(QAbstractBarSeries *series, QGraphicsItem* item = 0);
+    BarChartItem2(QAbstractBarSeries *series, QQuickItem* item = 0);
 
 private Q_SLOTS:
     void handleLabelsPositionChanged();
diff --git a/src/charts/barchart/vertical/bar/qbarseries.cpp b/src/charts/barchart/vertical/bar/qbarseries.cpp
index 7dc41d6c..6fc04574 100644
--- a/src/charts/barchart/vertical/bar/qbarseries.cpp
+++ b/src/charts/barchart/vertical/bar/qbarseries.cpp
@@ -131,12 +131,12 @@ void QBarSeriesPrivate::initializeGraphics(QGraphicsItem* parent)
     QAbstractSeriesPrivate::initializeGraphics(parent);
 }
 
-void QBarSeriesPrivate::initializeGraphics2(QGraphicsItem* parent)
+void QBarSeriesPrivate::initializeGraphics2(QQuickItem* parent)
 {
     Q_Q(QBarSeries);
     BarChartItem2 *bar = new BarChartItem2(q,parent);
     m_item2.reset(bar);
-    QAbstractSeriesPrivate::initializeGraphics(parent);
+    QAbstractSeriesPrivate::initializeGraphics2(parent);
 }
 
 QT_CHARTS_END_NAMESPACE
diff --git a/src/charts/barchart/vertical/bar/qbarseries_p.h b/src/charts/barchart/vertical/bar/qbarseries_p.h
index 3f35814b..70584d44 100644
--- a/src/charts/barchart/vertical/bar/qbarseries_p.h
+++ b/src/charts/barchart/vertical/bar/qbarseries_p.h
@@ -52,7 +52,7 @@ class QT_CHARTS_PRIVATE_EXPORT QBarSeriesPrivate: public QAbstractBarSeriesPriva
 public:
     QBarSeriesPrivate(QBarSeries *q);
     void initializeGraphics(QGraphicsItem* parent);
-    void initializeGraphics2(QGraphicsItem* parent);
+    void initializeGraphics2(QQuickItem* parent);
     void initializeDomain();
 
 private:
diff --git a/src/charts/chartelement2.cpp b/src/charts/chartelement2.cpp
index db06b649..efac1495 100644
--- a/src/charts/chartelement2.cpp
+++ b/src/charts/chartelement2.cpp
@@ -38,8 +38,8 @@
 QT_CHARTS_BEGIN_NAMESPACE
 
 
-ChartElement2::ChartElement2(QGraphicsItem* item):
-      QGraphicsObject(item),
+ChartElement2::ChartElement2(QQuickItem* item):
+      QQuickItem(item),
       m_presenter(0),
       m_themeManager(0),
       m_dataSet(0)
diff --git a/src/charts/chartelement2_p.h b/src/charts/chartelement2_p.h
index 1dab7d05..555c6f18 100644
--- a/src/charts/chartelement2_p.h
+++ b/src/charts/chartelement2_p.h
@@ -44,6 +44,7 @@
 #include <QtCore/QRect>
 #include <QGraphicsObject>
 #include <QtCharts/private/qchartglobal_p.h>
+#include <QQuickItem>
 
 QT_CHARTS_BEGIN_NAMESPACE
 
@@ -54,11 +55,11 @@ class ChartThemeManager;
 class AbstractDomain;
 class ChartDataSet;
 
-class QT_CHARTS_PRIVATE_EXPORT ChartElement2: public QGraphicsObject
+class QT_CHARTS_PRIVATE_EXPORT ChartElement2: public QQuickItem
 {
 
 public:
-    explicit ChartElement2(QGraphicsItem* item = 0);
+    explicit ChartElement2(QQuickItem* item = 0);
 
     virtual ChartAnimation *animation() const { return 0; }
     virtual void setPresenter(ChartPresenter2 *presenter);
diff --git a/src/charts/chartitem2.cpp b/src/charts/chartitem2.cpp
index 2ee0943b..c7f3f9fe 100644
--- a/src/charts/chartitem2.cpp
+++ b/src/charts/chartitem2.cpp
@@ -31,10 +31,11 @@
 #include <private/qabstractseries_p.h>
 #include <private/abstractdomain_p.h>
 #include <QtGui/QPainter>
+#include <QQuickItem>
 
 QT_CHARTS_BEGIN_NAMESPACE
 
-ChartItem2::ChartItem2(QAbstractSeriesPrivate *series,QGraphicsItem* item):
+ChartItem2::ChartItem2(QAbstractSeriesPrivate *series,QQuickItem* item):
       ChartElement2(item),
       m_validData(true),
       m_series(series)
diff --git a/src/charts/chartitem2_p.h b/src/charts/chartitem2_p.h
index feb99fa7..911e43f7 100644
--- a/src/charts/chartitem2_p.h
+++ b/src/charts/chartitem2_p.h
@@ -41,7 +41,8 @@
 
 #include "chartelement2_p.h"
 #include <QtCharts/private/qchartglobal_p.h>
-#include <QtWidgets/QGraphicsItem>
+#include <QQuickItem>
+#include "chartitem_p.h"
 
 QT_CHARTS_BEGIN_NAMESPACE
 
@@ -50,9 +51,9 @@ class QAbstractSeriesPrivate;
 class QT_CHARTS_PRIVATE_EXPORT ChartItem2 : public ChartElement2
 {
     Q_OBJECT
-    enum ChartItemTypes { AXIS_ITEM = UserType + 1, XYLINE_ITEM };
+    enum ChartItemTypes { AXIS_ITEM = ChartItem::UserType + 1, XYLINE_ITEM };
 public:
-    ChartItem2(QAbstractSeriesPrivate *series,QGraphicsItem* item);
+    ChartItem2(QAbstractSeriesPrivate *series,QQuickItem* item);
     AbstractDomain*  domain() const;
     virtual void cleanup();
 
